import { Collection, Entity, OneToMany, PrimaryKey, Property } from '@mikro-orm/core'
import { Character } from './character'
import { PasswordResetToken } from './passwordResetToken'

@Entity()
export class User {
  @PrimaryKey()
  id!: number

  @Property({ unique: true })
  username!: string

  @Property({ unique: true })
  email!: string

  @Property()
  password!: string

  @Property()
  online = false

  @OneToMany(() => Character, (character) => character.user)
  characters = new Collection<Character>(this)

  @OneToMany(() => PasswordResetToken, (token) => token.user)
  passwordResetTokens = new Collection<PasswordResetToken>(this)
}
