import { Entity, Enum, ManyToOne, OneToOne, PrimaryKey, Property } from '@mikro-orm/core'
import { Zone } from './zone'
import { ZoneEventTileType } from '#utilities/enums'
import { ZoneEventTileTeleport } from './zoneEventTileTeleport'

@Entity()
export class ZoneEventTile {
  @PrimaryKey()
  id!: string

  @ManyToOne(() => Zone)
  zone!: Zone

  @Enum(() => ZoneEventTileType)
  type!: ZoneEventTileType

  @Property()
  positionX!: number

  @Property()
  positionY!: number

  @OneToOne(() => ZoneEventTileTeleport, (teleport) => teleport.zoneEventTile)
  teleport?: ZoneEventTileTeleport
}
