import { gameLogger } from '#utilities/logger'
import { BaseRepository } from '#repositories/baseRepository'
import { World } from '#entities/world'

class WorldRepository extends BaseRepository {
  async getFirst(): Promise<any> {
    try {
      const repository = this.em.getRepository(World)
      return await repository.findOne({})
    } catch (error: any) {
      gameLogger.error(`Failed to get first world: ${error instanceof Error ? error.message : String(error)}`)
    }
  }
}

export default new WorldRepository()
